Page MenuHomePhabricator

Allow to keep for later any article selected in the new translation dialog
Open, NormalPublic

Description

Content Translation dashboard provides suggestions that users can keep for later. However, currently there is no way for users to add an article of their choice to translate later. This will enable users to organize their translation efforts into the default "for later" list.

In order to support this, the following is proposed:

  • Add a bookmarking icon next to the language selector for the article. The icon should be the same used elsewhere for keeping for later, which currently it is a star, but there are plans to make it a bookmark (T178790).
  • If the selected article is already in the "For later" list, the bookmarking icon will be shown using the filled version.

The idea is illustrated below:

Providing feedback

We want to indicate to the user where the article went (i.e., the "for later" list in the Suggestions view). After saving the article for later, a tooltip showing the message "Kept for later! Access all your translation ideas from the Suggestions view".


There is a related ticket to improve the communication of this feedback in a different context: T125379: Feedback when a suggestion (or list of suggestions) is kept for later

Details

Related Gerrit Patches:
mediawiki/extensions/ContentTranslation : masterTake multiple languages into account when working with suggestion list
mediawiki/extensions/ContentTranslation : masterUpdate bookmark status for selected article
mediawiki/extensions/ContentTranslation : masterAllow to keep for later any article selected in the new translation dialog

Event Timeline

Pginer-WMF triaged this task as Normal priority.Mar 1 2018, 4:41 PM
Pginer-WMF created this task.
Restricted Application added a subscriber: Aklapper. · View Herald TranscriptMar 1 2018, 4:41 PM

What should happen visually when "Keep for later" button is clicked?
Page reload (probably no)? Some animation? I guess we want user to stay at the same page (no reload to happen), but communicating that selected page for translation goes to "For later" list could be tricky to design.

What should happen visually when "Keep for later" button is clicked?
Page reload (probably no)? Some animation? I guess we want user to stay at the same page (no reload to happen), but communicating that selected page for translation goes to "For later" list could be tricky to design.

Yes, we may want to communicate where the page went. I'll add a note to the description for that aspect to be detailed as we focus on that area of work.

Pginer-WMF updated the task description. (Show Details)
Pginer-WMF updated the task description. (Show Details)
Pginer-WMF updated the task description. (Show Details)Jul 26 2019, 10:53 AM

@Pginer-WMF Since same dialog layout is used when user clicks on some suggested article, do we show the bookmark icon in that case as well?

Also, what should happen when article is marked as favorite while Suggestions list is opened? Should the transition happen like when it's added from regular suggestion items?

Description says tooltip should be shown, but what does that mean? Is it like tooltip we get with mw.notify or tooltip like in T125379, which is yet to be developed?

Change 527102 had a related patch set uploaded (by Petar.petkovic; owner: Petar.petkovic):
[mediawiki/extensions/ContentTranslation@master] Allow to keep for later any article selected in the new translation dialog

https://gerrit.wikimedia.org/r/527102

Good questions @Petar.petkovic

I think it makes sense to also include the bookmark icon on the dialog shown for some suggested article the user clicked. That makes the experience of starting a new translation more consistent.

I have been thinking a bit more about the feedback in the different situations, and I'd propose using mw.notify, adjusting the message depending on the following cases:

Marking for later from a dialog in the In-progress or Published view:

  • Show message: "Added for later! Check the suggestions view anytime."

Marking for later from a dialog in the Suggestions view

  • Show message: "Added for later!"

Marking for later from the list in the Suggestions view
(this last case would resolve T125379, so it is up to you to address it as part of this implementation effort or... ...keep it for later)

  • Only when the viewport top is hiding anything above the first suggested item, show message: "Added for later!"
  • When the viewport allows seeing how the "For later" list is created or expanded, show nothing.

Does this make sense? Is there any other detail needed?

Thanks @Pginer-WMF for detailed and well structured answer. I have one more question, just to make sure I understand.

Cases 1. and 2. cover user adding selected article to favorites from New translation dialog when In-progress or Published list and Suggestions list are open, respectively.
Case 3. covers clicking on bookmark icon (what used to be a star) inside some suggested item on Suggestions list.

When user clicks on suggested article inside Suggestions list, dialog same as New translation opens. Per your comment, we should show the bookmark icon inside that dialog as well. Should clicking on that icon be covered by case number 2?

When user clicks on suggested article inside Suggestions list, dialog same as New translation opens. Per your comment, we should show the bookmark icon inside that dialog as well. Should clicking on that icon be covered by case number 2?

Yes. That's covered by case 2. We show feedback, but don't include a reference to the "Suggestions view" since the user is already there.

Change 534207 had a related patch set uploaded (by Petar.petkovic; owner: Petar.petkovic):
[mediawiki/extensions/ContentTranslation@master] Update bookmark status for selected article

https://gerrit.wikimedia.org/r/534207

Change 527102 merged by jenkins-bot:
[mediawiki/extensions/ContentTranslation@master] Allow to keep for later any article selected in the new translation dialog

https://gerrit.wikimedia.org/r/527102

Change 534207 merged by jenkins-bot:
[mediawiki/extensions/ContentTranslation@master] Update bookmark status for selected article

https://gerrit.wikimedia.org/r/534207

Jpita added a subscriber: Jpita.Oct 18 2019, 10:12 AM

@Petar.petkovic were you able to see this working on local?
on cx2-testing and prod I see the bookmark button but nothing is added to the for later list

@Petar.petkovic were you able to see this working on local?
on cx2-testing and prod I see the bookmark button but nothing is added to the for later list

Yes, I tested quite extensively on localhost during development.
Now I checked in production as well, using Serbian Wikipedia. First, while I was on dashboard suggestion view, I opened New translation dialog, found some random article which is missing in Serbian and bookmarked it. Popup message appeared. Page needed to be reloaded to see the changes.

Then I opened CX with draft view. Clicked New translation dialog again and found random missing article. Bookmarked it and closed New translation dialog. Then I switched to Suggestions view (notice that this is first time I load Suggestions in this session) to see both favorite articles being there.

Jpita added a comment.Mon, Oct 21, 7:05 AM

Issues found:

  • removing article from "new translation" doesn't update list - needs reloading of the page video, the same for adding to the list, requires reloading
  • https://phabricator.wikimedia.org/T194476 happens on this feature as well - if we change the target language on the "new translation" the bookmarked article doesn't show on the bookmarks: example video

According to our discussion on telegram, these issues are mainly due to technical limitations of the platform.
I'll let @Pginer-WMF decide if this is ok to go live like this or not.
@Petar.petkovic regarding the other task related to this one

If this is too hard for you and too laborious, we can move ticket back to In review until https://gerrit.wikimedia.org/r/537781 is merged, after which favorites should no longer be deleted

, as I said on telegram, I'd prefer to have it merged before this one so I can test it all together

Change 537781 had a related patch set uploaded (by Petar.petkovic; owner: Petar.petkovic):
[mediawiki/extensions/ContentTranslation@master] Take multiple languages into account when working with suggestion list

https://gerrit.wikimedia.org/r/537781

Issues found:

  • removing article from "new translation" doesn't update list - needs reloading of the page video, the same for adding to the list, requires reloading

When you have Suggestions view open, adding/removing items using bookmark icon will require refresh. Popup notice with message saying that article is added for later is what we settled for. If you perform same actions when your In progress or Published lists are opened, and then navigate to Suggestions without reload, those new additions will show.

  • T194476 happens on this feature as well - if we change the target language on the "new translation" the bookmarked article doesn't show on the bookmarks: example video

The reason is that article you selected exists in Catalan and when you reload, Catalan is selected as target language. Thus, article is considered as existing and removed from the list of favorites. Patch 537781 is meant to deal with this problem.